
From: Oleg Drokin <green@namesys.com>

This patch fixes various bad stuff that happens when you write to full or
almost full reiserfs filesystem.



 25-akpm/fs/reiserfs/bitmap.c |    4 ++--
 25-akpm/fs/reiserfs/file.c   |    2 ++
 2 files changed, 4 insertions(+), 2 deletions(-)

diff -puN fs/reiserfs/bitmap.c~reiserfs-enospc-fix fs/reiserfs/bitmap.c
--- 25/fs/reiserfs/bitmap.c~reiserfs-enospc-fix	Thu Jul 31 13:32:07 2003
+++ 25-akpm/fs/reiserfs/bitmap.c	Thu Jul 31 13:32:07 2003
@@ -910,11 +910,11 @@ void reiserfs_release_claimed_blocks( 
 int reiserfs_can_fit_pages ( struct super_block *sb /* superblock of filesystem
 						       to estimate space */ )
 {
-	b_blocknr_t space;
+	int space;
 
 	spin_lock(&REISERFS_SB(sb)->bitmap_lock);
 	space = (SB_FREE_BLOCKS(sb) - REISERFS_SB(sb)->reserved_blocks) >> ( PAGE_CACHE_SHIFT - sb->s_blocksize_bits);
 	spin_unlock(&REISERFS_SB(sb)->bitmap_lock);
 
-	return space;
+	return space>0?space:0;
 }
diff -puN fs/reiserfs/file.c~reiserfs-enospc-fix fs/reiserfs/file.c
--- 25/fs/reiserfs/file.c~reiserfs-enospc-fix	Thu Jul 31 13:32:07 2003
+++ 25-akpm/fs/reiserfs/file.c	Thu Jul 31 13:32:07 2003
@@ -1085,6 +1085,8 @@ ssize_t reiserfs_file_write( struct file
 	    // 100% of disk space anyway.
 	    write_bytes = min_t(int, count, inode->i_sb->s_blocksize - (pos & (inode->i_sb->s_blocksize - 1)));
 	    num_pages = 1;
+	    // No blocks were claimed before, so do it now.
+	    reiserfs_claim_blocks_to_be_allocated(inode->i_sb, 1 << (PAGE_CACHE_SHIFT - inode->i_blkbits));
 	}
 
 	/* Prepare for writing into the region, read in all the

_
